#include "stdafx.h"

using namespace std;

typedef unsigned char tmac[6];

struct MAGICSEQUENCE {
	tmac pre;
	tmac mac[16];
	tmac pas;
};

unsigned int CountOfHexDigits(string& s)
{
	unsigned int c = 0;
	for(unsigned int i=0; i<s.length(); i++) {
		if(isxdigit(s[i])) c++;
	}
	return c;
}

BYTE* Hex2Bin(string& s)
{
	static BYTE mac[6];
	BYTE a, c;
	BYTE *pt = &mac[0];
	BOOL first = FALSE;
	for(unsigned int i=0; i<s.length(); i++) {
		c = s[i];
		if((c>47 && c<58) || (c>64 && c<71) || (c>96 && c<123)) {
			if(c>47 && c<58)  a = (c-48);
			if(c>64 && c<71)  a = (c-55);
			if(c>96 && c<123) a = (c-87);
			if(first) {
				*pt |= a;
				pt++;
				first = FALSE;
			} else {
				*pt = (a<<4);
				first = TRUE;
			}
		} else {
			first = FALSE;
		}
	}
	return mac;
}

void ShowHelp()
{
	cout << _T("wakeup [mac] [group ip address] [port] [password]") << endl << endl;
	cout << _T("To discover physical (MAC) the address of the local computer execute:") << endl;
	cout << _T("getmac /v") << endl << endl;
	cout << _T("Or:") << endl;
	cout << _T("ipconfig /all") << endl << endl;
	cout << _T("Or:") << endl;
	cout << _T("netsh interface ipv4 show ipnettomedia") << endl << endl;
	cout << _T("For remote witch IP 192.168.0.123:") << endl;
	cout << _T("getmac /S 192.168.0.123 /U Administrator /P Password") << endl << endl;
	cout << _T("Or:") << endl;
	cout << _T("ping 192.168.0.123") << endl;
	cout << _T("arp -a") << endl << endl;
	return; 
}

int _tmain(int argc, _TCHAR* argv[])
{
	setlocale(LC_ALL, "Russian");
	cout << _T("Wake on LAN (c) 2012 Yaroslav & Anna") << endl << endl;

	string smac, saddress, sport, spassword;
	int iCountBytesToSend = sizeof(MAGICSEQUENCE) - sizeof(tmac);
	unsigned short usPort = 0xFFFF;

	if(argc == 1) {
		cout << _T("MAC? No more than 12 hex digits.....................:");
		getline(cin, smac);
		cout << _T("Address? Can be empty for 255.255.255.255...........:");
		getline(cin, saddress);
		cout << _T("Port? Can be empty for 0xFFFF or input number here..:");
		getline(cin, sport);
		cout << _T("Password? Can be empty or no more than 12 hex digits:");
		getline(cin, spassword);
		cout << endl;
	} else if (argc == 2) {
		if(!strcmp(_T("/?"), argv[1]) || !strcmp(_T("?"), argv[1])) {
			ShowHelp();
			return 0;
		} else {
			smac = argv[1];
			saddress = _T("255.255.255.255");
			spassword = _T("");
		}
	} else if (argc == 3) {
		smac = argv[1];
		saddress = argv[2];
		spassword = _T("");
	} else if (argc == 4) {
		smac = argv[1];
		saddress = argv[2];
		usPort = atoi(argv[3]);
		spassword = _T("");
	} else if (argc == 5) {
		smac = argv[1];
		saddress = argv[2];
		usPort = atoi(argv[3]);
		spassword = argv[4];
	} else {
		ShowHelp();
		return 0;
	}
	MAGICSEQUENCE ms = { 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF }; 
	try {
		if(CountOfHexDigits(smac) != 12) throw _T("Invalid MAC address");
		if(spassword.length() > 12) throw _T("Invalid password");
	} catch(char* error) {
		cout << error << endl;
		return 1;
	}
	unsigned char* ucMac = Hex2Bin(smac);
	for(int i=0; i<16; i++) {
		memcpy(&ms.mac[i], ucMac, sizeof(tmac));
	}
	if(!saddress.length()) saddress = _T("255.255.255.255");
	if(sport.length()) usPort = atoi(sport.c_str());
	if(spassword.length()) {
		memset(&ms.pas, 0, sizeof(tmac));
		memcpy(&ms.pas, Hex2Bin(spassword), spassword.length() / 2 % 7);
		iCountBytesToSend += sizeof(tmac);
	}
	WSADATA	wsaData;
    WORD wVersionRequested = MAKEWORD(2, 2); 
	if(WSAStartup(wVersionRequested , &wsaData)) {
		wsaData.wVersion = 0;
		cout << _T("Error of startup network subsystem, errorcode: ") << WSAGetLastError() << endl;
		WSACleanup();
		return 2;
	}
	SOCKET s = socket(AF_INET, SOCK_DGRAM, IPPROTO_UDP);
	if(s == INVALID_SOCKET) {
		cout << _T("Error of create socket, errorcode: ") << WSAGetLastError() << endl;
		WSACleanup();
		return 3;
	}

	SOCKADDR_IN sAdrOut;
	int Errors = 0;
	BOOL bYes = TRUE;
	sAdrOut.sin_family = AF_INET;
	sAdrOut.sin_addr.s_addr = inet_addr(saddress.c_str());
	sAdrOut.sin_port = htons(usPort);

	Errors = setsockopt(s, SOL_SOCKET, SO_BROADCAST, (char*)&bYes, sizeof(bYes));	
	Errors = sendto(s, (char*)&ms, iCountBytesToSend, 0, (sockaddr*)&sAdrOut, sizeof(sAdrOut));
	if(Errors == SOCKET_ERROR) {
		cout << _T("Unable send magic sequence, errorcode: ") << WSAGetLastError() << endl;
	} else if (Errors == iCountBytesToSend) {
		cout << _T("Magic sequence is successfully sent to ") << saddress << ":" << usPort << endl;
	}
	Errors = closesocket(s);
	if(wsaData.wVersion) WSACleanup();
	return 0;
}
